"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var styles_1 = require("../../styles");
var utils_1 = require("../../utils");
var Button = /** @class */ (function (_super) {
    __extends(Button, _super);
    function Button(props) {
        var _this = _super.call(this, props) || this;
        _this.openAnimation = function () {
            var _a = _this.props, x = _a.x, y = _a.y;
            react_native_1.Animated.spring(_this.state.pan, {
                toValue: { x: x, y: y },
            }).start();
        };
        _this.scaleAnimation = function (toValue) {
            react_native_1.Animated.spring(_this.state.scale, {
                speed: 20,
                toValue: toValue,
            }).start();
        };
        _this.state = {
            hover: false,
            pan: new react_native_1.Animated.ValueXY(),
            scale: new react_native_1.Animated.Value(1),
            touchable: false,
        };
        return _this;
    }
    Button.prototype.componentDidMount = function () {
        this.openAnimation();
    };
    Button.prototype.componentDidUpdate = function (prevProps) {
        var _a = this.props, active = _a.active, vibrate = _a.vibrate, vibrateDuration = _a.vibrateDuration;
        if (active && !prevProps.active) {
            if (vibrate) {
                react_native_1.Vibration.vibrate(vibrateDuration, false);
            }
            this.scaleAnimation(1.2);
        }
        else if (!active && prevProps.active) {
            this.scaleAnimation(1);
        }
    };
    Button.prototype.render = function () {
        var _a = this.props, backgroundColor = _a.backgroundColor, buttonDiameter = _a.buttonDiameter, children = _a.children;
        var _b = this.state, pan = _b.pan, scale = _b.scale;
        return (<react_native_1.Animated.View style={[
            styles_1.styles.button,
            __assign({ backgroundColor: backgroundColor }, utils_1.getSizeStyles(buttonDiameter)),
            pan.getLayout(),
            {
                transform: [{ scale: scale }],
            },
        ]}>
        <react_native_1.View>{children}</react_native_1.View>
      </react_native_1.Animated.View>);
    };
    return Button;
}(React.PureComponent));
exports.Button = Button;
//# sourceMappingURL=Button.js.map