"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    }
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var react_native_1 = require("react-native");
var components_1 = require("../../components");
var constants_1 = require("../../constants");
var BACKGROUND_COLOR = constants_1.DEFAULT_OPTIONS.BACKGROUND_COLOR, BUTTON_DIAMETER = constants_1.DEFAULT_OPTIONS.BUTTON_DIAMETER, MENU_DIAMETER = constants_1.DEFAULT_OPTIONS.MENU_DIAMETER, OPEN_DELAY = constants_1.DEFAULT_OPTIONS.OPEN_DELAY, SPREAD_RADIUS = constants_1.DEFAULT_OPTIONS.SPREAD_RADIUS, SPREAD_ANGLE = constants_1.DEFAULT_OPTIONS.SPREAD_ANGLE, VIBRATE = constants_1.DEFAULT_OPTIONS.VIBRATE, VIBRATE_DURATION = constants_1.DEFAULT_OPTIONS.VIBRATE_DURATION;
// tslint:disable-next-line:typedef
exports.withRadialActionMenu = function (
// tslint:disable-next-line:variable-name
Component) { var _a; return _a = /** @class */ (function (_super) {
        __extends(RadialMenu, _super);
        function RadialMenu(props) {
            var _this = _super.call(this, props) || this;
            _this.panResponder = { panHandlers: {} };
            _this.calculateButtonAngle = function (direction, index) {
                var _a = _this.props, buttons = _a.buttons, spreadAngle = _a.spreadAngle;
                var angle = (spreadAngle / buttons.length) * index;
                switch (direction) {
                    case constants_1.OPEN_DIRECTIONS.BOTTOM_RIGHT:
                        return 90 - spreadAngle + angle + (spreadAngle / buttons.length) * 1;
                    case constants_1.OPEN_DIRECTIONS.BOTTOM_LEFT:
                        return angle + 90;
                    case constants_1.OPEN_DIRECTIONS.TOP_LEFT:
                        return 270 - spreadAngle + angle + (spreadAngle / buttons.length) * 1;
                    default:
                        return angle + 270;
                }
            };
            _this.calculateDestinationCoords = function (radius, angle) { return ({
                x: radius * Math.cos(_this.convertDegreesToRadians(angle)),
                y: radius * Math.sin(_this.convertDegreesToRadians(angle)),
            }); };
            _this.calculateMenuBoundaries = function (coord, size, offset) {
                var menuDiameter = _this.props.menuDiameter;
                return Math.max(-offset, Math.min(coord - menuDiameter / 2, size - menuDiameter + offset));
            };
            _this.calculateOpenDirection = function (_a) {
                var nativeEvent = _a.nativeEvent;
                var _b = react_native_1.Dimensions.get("window"), height = _b.height, width = _b.width;
                var pageX = nativeEvent.pageX, pageY = nativeEvent.pageY;
                var xThreshold = width / 2;
                var yThreshold = height / 3;
                if (pageX < xThreshold && pageY < yThreshold) {
                    return constants_1.OPEN_DIRECTIONS.BOTTOM_RIGHT;
                }
                else if (pageX > xThreshold && pageY < yThreshold) {
                    return constants_1.OPEN_DIRECTIONS.BOTTOM_LEFT;
                }
                else if (pageX > xThreshold && pageY > yThreshold) {
                    return constants_1.OPEN_DIRECTIONS.TOP_LEFT;
                }
                return constants_1.OPEN_DIRECTIONS.TOP_RIGHT;
            };
            _this.convertDegreesToRadians = function (angle) {
                return (angle * Math.PI) / 180;
            };
            _this.findActiveButton = function (dx, dy) {
                var buttonDiameter = _this.props.buttonDiameter;
                var coords = _this.state.coords;
                var buttonRadius = buttonDiameter / 2;
                return coords.findIndex(function (_a) {
                    var x = _a.x, y = _a.y;
                    return dx > x - buttonRadius &&
                        dy > y - buttonRadius &&
                        dx < x + buttonRadius &&
                        dy < y + buttonRadius;
                });
            };
            _this.generatePanHandlers = function () {
                _this.panResponder = react_native_1.PanResponder.create({
                    onMoveShouldSetPanResponder: function () { return true; },
                    onPanResponderGrant: _this.handleResponderGrant,
                    onPanResponderMove: _this.handleResponderMove,
                    onPanResponderRelease: _this.handleResponderRelease,
                    onPanResponderTerminate: _this.handleResponderRelease,
                    onShouldBlockNativeResponder: function () { return false; },
                    onStartShouldSetPanResponder: function () { return true; },
                });
            };
            _this.getDestinationCoords = function (event) {
                var _a = _this.props, buttons = _a.buttons, spreadRadius = _a.spreadRadius;
                var direction = _this.calculateOpenDirection(event);
                return buttons.map(function (_, i) {
                    return _this.calculateDestinationCoords(spreadRadius, _this.calculateButtonAngle(direction, i));
                });
            };
            _this.handleLayout = function (_a) {
                var nativeEvent = _a.nativeEvent;
                var _b = nativeEvent.layout, height = _b.height, width = _b.width;
                _this.setState({ height: height, width: width });
            };
            _this.handleResponderGrant = function (event) {
                var openDelay = _this.props.openDelay;
                var _a = event.nativeEvent, locationX = _a.locationX, locationY = _a.locationY, pageX = _a.pageX, pageY = _a.pageY;
                var onOpen = _this.props.onOpen;
                var _b = _this.state, height = _b.height, width = _b.width;
                var coords = _this.getDestinationCoords(event);
                var x = _this.calculateMenuBoundaries(locationX, width, 0);
                var y = _this.calculateMenuBoundaries(locationY, height, 15); // Add slight vertical offset
                _this.longPressTimeout = window.setTimeout(function () {
                    if (onOpen) {
                        onOpen();
                    }
                    _this.setState({
                        closed: false,
                        coords: coords,
                        pageX: pageX,
                        pageY: pageY,
                        x: x,
                        y: y,
                    });
                }, openDelay);
            };
            _this.handleResponderMove = function (_, _a) {
                var dx = _a.dx, dy = _a.dy;
                var selected = _this.state.selected;
                var activeButtonIndex = _this.findActiveButton(dx, dy);
                if (activeButtonIndex > -1 && activeButtonIndex !== selected) {
                    _this.setState({ selected: activeButtonIndex });
                }
                else if (selected !== activeButtonIndex) {
                    _this.setState({ selected: null });
                }
            };
            _this.handleResponderRelease = function () {
                window.clearTimeout(_this.longPressTimeout);
                var _a = _this.props, buttons = _a.buttons, onClose = _a.onClose;
                var selected = _this.state.selected;
                if (onClose) {
                    if (typeof selected === "number") {
                        onClose(buttons[selected].value);
                    }
                    else {
                        onClose(null);
                    }
                }
                _this.setState({ closed: true });
            };
            _this.state = {
                closed: true,
                coords: [],
                height: 0,
                pageX: 0,
                pageY: 0,
                selected: null,
                width: 0,
                x: 0,
                y: 0,
            };
            _this.generatePanHandlers();
            return _this;
        }
        RadialMenu.prototype.render = function () {
            var _a = this.props, backgroundColor = _a.backgroundColor, buttons = _a.buttons, buttonDiameter = _a.buttonDiameter, menuDiameter = _a.menuDiameter, vibrate = _a.vibrate, vibrateDuration = _a.vibrateDuration;
            var _b = this.state, coords = _b.coords, selected = _b.selected, x = _b.x, y = _b.y;
            return (<react_native_1.View {...this.panResponder.panHandlers}>
          <react_native_1.View onLayout={this.handleLayout}>
            <Component {...this.props}/>
          </react_native_1.View>
          {!this.state.closed && (<components_1.Menu coords={coords} backgroundColor={backgroundColor} buttons={buttons} buttonDiameter={buttonDiameter} menuDiameter={menuDiameter} selected={selected} vibrate={vibrate} vibrateDuration={vibrateDuration} x={x} y={y}/>)}
        </react_native_1.View>);
        };
        return RadialMenu;
    }(React.Component)),
    _a.defaultProps = {
        backgroundColor: BACKGROUND_COLOR,
        buttonDiameter: BUTTON_DIAMETER,
        menuDiameter: MENU_DIAMETER,
        openDelay: OPEN_DELAY,
        spreadAngle: SPREAD_ANGLE,
        spreadRadius: SPREAD_RADIUS,
        vibrate: VIBRATE,
        vibrateDuration: VIBRATE_DURATION,
    },
    _a; };
//# sourceMappingURL=withRadialActionMenu.js.map